
#ifndef LEX_ANALYSE_H
#define LEX_ANALYSE_H

#include "Almaz.h"

enum TokenType
{
    tt_unknown,     //  
    tt_comment,     // 
    tt_quote1,      //    
    tt_quote2,      //    
    tt_name,        // 
    tt_int,         //  
    tt_bin,         //  
    tt_hex,         //  
    tt_real,        //    
    tt_exp,         //       
// 
    tt_exclamation,         // !   33
    tt_sharp,               // #  35
    tt_percent,             // %  37
    tt_amper,               // & 
    tt_parenthesis_open,    // (   
    tt_parenthesis_close,   // )   
    tt_asterisk,            // *  42
    tt_plus,                // + 
    tt_comma,               // , 
    tt_minus,               // - 
    tt_dot,                 // . 
    tt_slash,               // /  
    tt_colon,               // : 
    tt_semicolon,           // ;   
    tt_less,                // < 
    tt_equal,               // = 
    tt_greater,             // >  62
    tt_question,            // ?  63
    tt_at,                  // @   64
    tt_bracket_open,        // [    91
    tt_bracket_close,       // ]    93
    tt_lid,                 // ^  94
    tt_braces_open,         // {    123
    tt_vertical,            // |   124
    tt_braces_close,        // }    125
    tt_tilde,               // ~  126
//  
    tt_exclamation_equal,   //  !=
    tt_percent_equal,       //  %=
    tt_amper_equal,         //  &=
    tt_asterisk_equal,      //  *=
    tt_plus_plus,           //  ++
    tt_plus_equal,          //  +=
    tt_minus_minus,         //  --
    tt_minus_equal,         //  -=
    tt_slash_equal,         //  /=
    tt_less_less,           //  <<
    tt_less_less_equal,     // <<=
    tt_less_equal,          //  <=
    tt_equal_equal,         //  ==
    tt_greater_greater,     //  >>
    tt_greater_equal,       //  >=
    tt_greater_greater_equal,// >>=
    tt_lid_equal,           //  ^=
    tt_vertical_equal,      //  |=
//  
// 2
    tt_if,
// 3
    tt_for,
// 4
    tt_auto,
    tt_else,
    tt_goto,
    tt_int8,
    tt_log8,
    tt_nat8,
    tt_true,
    tt_void,
// 5
    tt_break,
    tt_char8,
    tt_const,
    tt_false,
    tt_int16,
    tt_int32,
    tt_int64,
    tt_label,
    tt_local,
    tt_nat16,
    tt_nat32,
    tt_nat64,
// 6
    tt_extern,
    tt_global,
    tt_real32,
    tt_real64,
    tt_return,
    tt_static,
// 7
// 8
    tt_continue,
//  
    tt_eof,
// 
    tt_DataType,
    tt_ReturnType,
    tt_AssignOperator,
    tt_Operation,
    tt_Number,
    tt_Expression2,
    tt_Expression1,
    tt_ExpressionParenthesisClose2,
    tt_ExpressionParenthesisClose1,
    tt_ExpressionParenthesisClose,
    tt_ExpressionBracesClose2,
    tt_ExpressionBracesClose1,
    tt_ExpressionBracesClose,
    tt_ExpressionSemicolon2,
    tt_ExpressionSemicolon1,
    tt_ExpressionSemicolon,
    tt_ExpressionList3,
    tt_ExpressionList2,
    tt_ExpressionList1,
    tt_ExpressionList,
    tt_Statement1,
    tt_DataDefinition2,
    tt_DataDefinition,
    tt_Statement,
    tt_StatementList,
    tt_Argument2,
    tt_Argument,
    tt_ArgumentList2,
    tt_ArgumentList,
    tt_SubProgramType,
    tt_Type,
    tt_Definition2,
    tt_Definition,
    tt_Declaration,
    tt_DeclarationList,
    tt_Program
};

enum LexReturn
{
    lr_ok,
    lr_bad_bin,
    lr_bad_hex,
    lr_bad_num,
    lr_no_quote1,
    lr_no_quote2,
    lr_open_comment,
    lr_unknown_character,
};

struct Token
{
    TokenType type;
    const char8 * text;
    nat32 size;
};

#endif