
#ifndef SYNTAX_H
#define SYNTAX_H

#include "lex_analyse.h"
#include "ShevList.h"

class Rule;
class RuleAtom;

typedef  Item<const RuleAtom *> ItemRAP;
class ListRAP : public List<ItemRAP> {};

class GSymbol
{
public:
    const TokenType type;
    const Rule * const rule;
    ListRAP list;
    GSymbol ( const Rule * r, TokenType t );
};

class RuleAtom
{
public:
    const RuleAtom * next;
    const GSymbol  * symbol;
    explicit RuleAtom ( const GSymbol * s, const RuleAtom * a = 0 ) : symbol(s), next(a) {}
};

class Rule
{
public:
    const RuleAtom * atom;
    const Rule     * next;
    explicit Rule ( const RuleAtom * a, const Rule * r = 0 ) : atom(a), next(r) {}
};

extern const RuleAtom * const start;

#endif