// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Translator.h"

#include "MainFrm.h"

#include "TranslatorDoc.h"
#include "TranslatorView.h"

#include "core\Translate.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_A_TO_CPP, OnAToCpp)
	ON_COMMAND(ID_PROJECT_SAVE_CPP_CODE, OnSaveCPPCode)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
    if ( ! m_wndSplitter.CreateStatic ( this, 1, 2 ) )
    {
        TRACE("Failed to CreateStaticSplitter");
        return(FALSE);
    }
	
    CRect rectClient;
    GetClientRect ( rectClient );
    CSize size = rectClient.Size();
    size.cx /= 2;
    size.cy /= 2;

    m_wndSplitter.CreateView ( 0, 0, RUNTIME_CLASS( CTranslatorView ), size, pContext );
    m_wndSplitter.CreateView ( 0, 1, RUNTIME_CLASS( CTranslatorView ), size, pContext );

	CTranslatorView * pLeftView = ( CTranslatorView * )m_wndSplitter.GetPane(0, 0);
	( pLeftView->GetRichEditCtrl() ).SendMessage(EM_SETTARGETDEVICE, 0, 1);    //   
    pLeftView->colorize();                                                     //     
		

	CRichEditView * pRighView = ( CRichEditView * )m_wndSplitter.GetPane(0, 1);
	( pRighView->GetRichEditCtrl() ).SendMessage(EM_SETREADONLY, TRUE, NULL);  //    .	
	( pRighView->GetRichEditCtrl() ).SendMessage(EM_SETTARGETDEVICE, 0, 1);    //   
    
	return TRUE;
}
//***********************************************************************
//****                      CPP                     ****    
//***********************************************************************
void CMainFrame::OnAToCpp() 
{
	CString source;
	CTranslatorView *pView1 = ( CTranslatorView * ) m_wndSplitter.GetPane(0, 0);
    pView1->colorize(); //     
	pView1->GetWindowText ( source );
    Suite<char8> vres;
    bool ok = translate (  source.GetLength(), (const char8 *)(LPCTSTR)source, vres );
    vres.addAftLas ( 0 );
	CString result ( &vres[0] );
    CTranslatorView *pView2 = ( CTranslatorView * ) m_wndSplitter.GetPane(0, 1);
    pView2->SetWindowText(result);
    pView2->colorize(); //     
}
//************************************************************************
//****                *.cpp            ****
//************************************************************************

void CMainFrame::OnSaveCPPCode() 
{

	CString csGetText;
	HANDLE hNewFile;
	DWORD dwBytesWritten = 0; 

	CFileDialog dlg( FALSE );
	CString str, path;

	str = "  *.cpp";
	str += ( TCHAR )NULL;
	str += "*.cpp";
	str += ( TCHAR )NULL;
	str += "  *.*";
	str += ( TCHAR )NULL;
	str += "*.*";
	str += ( TCHAR )NULL;

	dlg.m_ofn.lpstrFilter = str;
	dlg.m_ofn.nFilterIndex= 0;
	
	if (dlg.DoModal() == IDOK)
	{
		

		path = dlg.GetPathName();  
        if ( path.Find( ".cpp" ) == -1 )
		{
			path.Insert( path.GetLength(), ".cpp" );
		}

		
   	    m_wndSplitter.GetPane( 0, 1 )->GetWindowText( csGetText );

		if (strlen(csGetText) != 0)
		{

		
			hNewFile = CreateFile(
			                  __TEXT( path ) ,
							  GENERIC_READ | GENERIC_WRITE, 
							  0,
							  NULL, 
							  CREATE_ALWAYS,
							  FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN, 
							  NULL
			
							  ); 
			WriteFile( 
			      hNewFile, 
				  csGetText, 
				  csGetText.GetLength(), 
				  &dwBytesWritten, 
				  NULL 
			      );
			CloseHandle( hNewFile );
		}
		else
		{
			MessageBox(" .",NULL, MB_OK);
		}
	}


}