// TranslatorView.cpp : implementation of the CTranslatorView class
//

#include "stdafx.h"
#include "Translator.h"

#include "TranslatorDoc.h"
#include "TranslatorView.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTranslatorView

IMPLEMENT_DYNCREATE(CTranslatorView, CRichEditView)

BEGIN_MESSAGE_MAP(CTranslatorView, CRichEditView)
	//{{AFX_MSG_MAP(CTranslatorView)
	ON_WM_VSCROLL()
	ON_WM_MOUSEWHEEL()
	ON_WM_CHAR()
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTranslatorView construction/destruction

#define ALMAZ_KEY_WORDS "auto,int8,log8,nat8,char8,int16,int32,int64,label,local,nat16,nat32,nat64,global,real32,real64"

CTranslatorView::CTranslatorView()
{
	sc.AddKeyword(ALMAZ_KEY_WORDS, RGB(0,155,255), GRP_KEYWORD);
}

CTranslatorView::~CTranslatorView()
{
}

BOOL CTranslatorView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CRichEditView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTranslatorView drawing

void CTranslatorView::OnDraw(CDC* pDC)
{
	CTranslatorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
}

/////////////////////////////////////////////////////////////////////////////
// CTranslatorView diagnostics

#ifdef _DEBUG
void CTranslatorView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CTranslatorView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CTranslatorDoc* CTranslatorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTranslatorDoc)));

	return (CTranslatorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTranslatorView message handlers

void CTranslatorView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	CRichEditView::OnVScroll(nSBCode, nPos, pScrollBar);
}

BOOL CTranslatorView::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	return CRichEditView::OnMouseWheel(nFlags, zDelta, pt);
}

void CTranslatorView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CRichEditView::OnChar(nChar, nRepCnt, nFlags);
}

void CTranslatorView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
//    colorize();
	CRichEditView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CTranslatorView::colorize()
{
    CRichEditCtrl & ctrl = GetRichEditCtrl();
	long mask = ctrl.GetEventMask();
	ctrl.SetEventMask(mask |= ENM_CHANGE );
	ctrl.SetRedraw(FALSE);
	sc.Colorize( 0, -1, & ctrl );
	ctrl.SetSel(0,0);
	ctrl.SetRedraw(TRUE);
	ctrl.RedrawWindow();
}